#!/usr/bin/perl -w
##---------------------------------------------------------------------------
##  Name:       nhsnow2grib2.pl
##
##  Author:     Jerry Guo  QSS Inc. July 2006
##  Language:   Perl script
##  Purpose:    This is a drive script that coolect information and convert nouthern hemisphere snow product into
##              GRIB2 with the information.##
##
##  Functions:  1). Collect information from file name and LWF file.
##              2). Call converter, nhsnow2grib2.f90 to convert the binary into GRIB2.
##              3). distribute the product and make clearning.
##
##  History:
##              Intial Version - Jan. 2007
##
##---------------------------------------------------------------------------

##--------------------------------------------------------------------------
## Define working directories and variables
##--------------------------------------------------------------------------

#use Date::Calc qw(:all);
use Math::BigInt::Calc qw(:all);
#my $work="/home/oper/grib2/fv/src/";
my $work="/home/Psnow/DEV/jsmith";
#my $data_in="/data/SNOW/NHSNOW/NHEM";
my $data_in="/data/Psnow/GLSNOW/NHEM/DATA";
#my $data_out="/data/SNOW/NHSNOW/NHEM/GRIB2/";
my $data_out="/data/Psnow/GLSNOW/NHEM/GRIB2/";
#nh_4km_multisensor_snow_ice_map_YYYYDDD
#nh_4km_multisensor_update_histr_YYYYDDD
#my $slash="/NH";
my $slash="/nh_4km_multisensor_snow_ice_map_";
my $slashD="/nh_4km_multisensor_update_histr_";
#my $point4=".C17_";
#my $point4="snow_ice_map_";
#my $post_in="_BLND_SID";
#my $post_inD="_BLND_DAY";
my $pre_grib2_ice="NH4km_autoice_";
my $pre_grib2_mice="NH4km_automice_";
my $pre_grib2_snow="NH4km_autosnow_";
my $post_grib2=".grb";
my $year=(gmtime(time))[5]+1900;
#my $d2year = sprintf("%2.2d",$year-2000);
my $month=(gmtime(time))[4]+1;
my $day=(gmtime(time))[3];
my $jday=(gmtime(time))[7]+1;
$day=sprintf('%02s',$day);
$month=sprintf('%02s',$month);
my $pyear=`date +%Y --date '1 day ago'`;
chomp($pyear);
my $pday=`date +%d --date '1 day ago'`; 
chomp($pday);
my $pmonth=`date +%m --date '1 day ago'`;
chomp($pmonth);
my $pmmddyyyy=`date +%m%d%Y --date '1 day ago'`;
chomp($pmmddyyyy);
my $pjday=`date +%j --date '1 day ago'`;
chomp($pjday);


my $filename_in;
my $filename_out_ice;
my $filename_out_mice;
my $filename_out_snow;

  if ($jday <= 9) {
   $jday = "00" . $jday;
  } elsif ( $jday <= 99) {
   $jday = "0" . $jday;
  } else {
   $jday = $jday + 0;
  }
$jday=$jday - 1;
$jday="0" . $jday;

#$filename_in = $data_in . $slash . $point4 . $pyear . $pjday . $post_in;
$filename_in = $data_in . $slash . $pyear . $pjday;
print "$filename_in\n";
#system ("cp $filename_in $data_in/NH.C17_YYYYDDD_BLND_SID"); 
system ("cp $filename_in $data_in/NH.MUL_YYYYDDD_BLND_SIM"); 
#$filename_inD = $data_in . $slash . $point4 . $pyear . $pjday . $post_inD;
$filename_inD = $data_in . $slashD . $pyear . $pjday;
print "$filename_inD\n";
#system ("cp $filename_inD $data_in/NH.C17_YYYYDDD_BLND_DAY");
system ("cp $filename_inD $data_in/NH.MUL_YYYYDDD_BLND_DAY");

$filename_out_ice = $data_out . $pre_grib2_ice . $pmmddyyyy . $post_grib2;
$filename_out_mice = $data_out . $pre_grib2_mice . $pmmddyyyy . $post_grib2;
#$filename_out_ice = $data_out . $pre_grib2_ice . $month . $pday . $year . $post_grib2;
#$filename_out_ice = $data_out . $pre_grib2_ice . $pmmddyyyy . $post_grib2;
print "$filename_out_ice\n";
$filename_out_snow = $data_out . $pre_grib2_snow . $pmmddyyyy . $post_grib2; 
#$filename_out_snow = $data_out . $pre_grib2_snow . $month . $pday . $year . $post_grib2; 
#$filename_out_snow = $data_out . $pre_grib2_snow . $pmmddyyyy . $post_grib2; 
print "$filename_out_snow\n";

#print "$work nhice2grib2 $filename_in $filename_inD $filename_out_ice $pyear $pmonth $pday\n";
#print "$work nhsnow2grib2 $filename_in $filename_inD $filename_out_snow $pyear $pmonth $pday\n";

print STDOUT "$filename_in $filename_inD $filename_out_ice\n";
system ("$work/glice2grib2 $filename_in $filename_inD $filename_out_mice $pyear $pmonth $pday");
system ("mv $filename_out_mice $filename_out_ice");
system ("$work/glsnow2grib2 $filename_in $filename_inD $filename_out_snow  $pyear $pmonth $pday");


exit
