#!/usr/bin/perl -w
##---------------------------------------------------------------------------
##  Name:       nhsnow2grib2.pl
##
##  Author:     Jerry Guo  QSS Inc. July 2006
##  Language:   Perl script
##  Purpose:    This is a drive script that coolect information and convert nouthern hemisphere snow product into
##              GRIB2 with the information.##
##
##  Functions:  1). Collect information from file name and LWF file.
##              2). Call converter, nhsnow2grib2.f90 to convert the binary into GRIB2.
##              3). distribute the product and make clearning.
##
##  History:
##              Intial Version - Jan. 2007
##
##---------------------------------------------------------------------------
#PATH=$PATH:$HOME:$HOME/bin:$HOME/mcidas/bin:/home/mcidas/bin:/home/mcidas/help:$HOME/mcidas/data:$HOME/mcidas/scripts:/usr/local/bin:/home/mcidas/data:.:
#MCPATH=$HOME:$HOME/mcidas/data:$HOME/mcidas/bin:$HOME/mcidas/bin/AVHRR_DATA:~mcidas/data:~mcidas/help:~mcidas/bin
#IDL_PATH=/usr/local/exelis/idl82/bin:/usr/local/exelis/idl82/lib:
#DISPLAY=0:0.0
#export PATH MCPATH IDL_PATH DISPLAY

##--------------------------------------------------------------------------
## Define working directories and variables
##--------------------------------------------------------------------------

#Math/BigInt/Calc.pm

#use Date::Calc qw(:all);
use Math::BigInt::Calc qw(:all);
#my $work="/home/oper/grib2/fv/src";
my $work="/home/Psnow/DEV/jsmith";
my $data_in="/data/Psnow/GLSNOW_2KM/SHEM/DATA";
#my $data_out="/data/SNOW/NHSNOW/NHEM/GRIB2/";
my $data_out="/data/Psnow/GLSNOW_2KM/SHEM/GRIB2/";
#nh_4km_multisensor_snow_ice_map_YYYYDDD
#nh_4km_multisensor_update_histr_YYYYDDD
#my $slash="/NH";
#my $slash="/sh_2km_multisensor_snow_ice_map_";
my $slash="/SH.MUL_";
#my $point4=".C17_";
#my $point4="snow_ice_map_";
#my $post_in="_BLND_SID";
#my $post_inD="_BLND_DAY";
my $pre_grib2_ice="SH2km_autoice_";
my $pre_grib2_snow="SH2km_autosnow_";
my $post_grib2=".grb";
my $year=(gmtime(time))[5]+1900;
#my $d2year = sprintf("%2.2d",$year-2000);
my $month=(gmtime(time))[4]+1;
my $day=(gmtime(time))[3];
my $jday=(gmtime(time))[7]+1;
$day=sprintf('%02s',$day);
$month=sprintf('%02s',$month);
my $pyear=`date +%Y --date '1 day ago'`;
chomp($pyear);
my $pday=`date +%d --date '1 day ago'`; 
chomp($pday);
my $pmonth=`date +%m --date '1 day ago'`;
chomp($pmonth);
my $pmmddyyyy=`date +%m%d%Y --date '1 day ago'`;
chomp($pmmddyyyy);
my $pjday=`date +%j --date '1 day ago'`;
chomp($pjday);


my $filename_in;
my $ddfname_in;
my $filename_out_ice;
my $filename_out_snow;

  if ($jday <= 9) {
   $jday = "00" . $jday;
  } elsif ( $jday <= 99) {
   $jday = "0" . $jday;
  } else {
   $jday = $jday + 0;
  }
$jday=$jday - 1;
$jday="0" . $jday;

#$filename_in = $data_in . $slash . $point4 . $pyear . $pjday . $post_in;
$filename_in = $data_in . $slash . $pyear . $pjday . _DCOM_BSM;
$ddfname_in = $data_in . $slash . $pyear . $pjday . _DCOM_DDF;
print "filename_in is $filename_in\n";
print "ddfname_in is $ddfname_in\n";
#system ("cp $filename_in $data_in/SH.2YYDAYSIM"); 
#$filename_inD = $data_in . $slash . $point4 . $pyear . $pjday . $post_inD;
#$filename_inD = $data_in . $slashD . $pyear . $pjday;
#print "$filename_inD\n";
#system ("cp $filename_inD $data_in/SH.C17_YYYYDDD_BLND_DAY");

$filename_out_ice = $data_out . $pre_grib2_ice . $pmmddyyyy . $post_grib2;
#$filename_out_ice = $data_out . $pre_grib2_ice . $month . $pday . $year . $post_grib2;
#$filename_out_ice = $data_out . $pre_grib2_ice . $pmmddyyyy . $post_grib2;
print "$filename_out_ice\n";
$filename_out_snow = $data_out . $pre_grib2_snow . $pmmddyyyy . $post_grib2; 
#$filename_out_snow = $data_out . $pre_grib2_snow . $month . $pday . $year . $post_grib2; 
#$filename_out_snow = $data_out . $pre_grib2_snow . $pmmddyyyy . $post_grib2; 
print "$filename_out_snow\n";

#system ("$work/glshice2grib2 $filename_in  $filename_out_ice $pyear $pmonth $pday");
#system ("$work/glshsnow2grib2 $filename_in $filename_out_snow  $pyear $pmonth $pday");
print "$work/glshice2grib2 $filename_in $ddfname_in $filename_out_ice $pyear $pmonth $pday";

print "$work/glshsnow2grib2 $filename_in $ddfname_in $filename_out_snow $pyear $pmonth $pday";

system ("$work/glshice2grib2 $filename_in $ddfname_in $filename_out_ice $pyear $pmonth $pday");

system ("$work/glshsnow2grib2 $filename_in $ddfname_in $filename_out_snow  $pyear $pmonth $pday");

#  OLD SH WAY 
#$filename_in = $data_in . $slash . $d2year . $jday;
#system ("cp $filename_in $data_in/SH.4YYDAYSIM");
#$filename_out_ice = $data_out . $pre_grib2_ice . $month . $day . $year . $post_grib2;
#$filename_out_snow = $data_out . $pre_grib2_snow . $month . $day . $year . $post_grib2;
#
#system ("$work/ice2grib2 $filename_in $filename_out_ice $year $month $day");
#system ("$work/snow2grib2 $filename_in $filename_out_snow  $year $month $day");

exit
